<template>
  <v-app>
    <v-app-bar app>
      <v-container>
        <v-row align="center" align-content="center">
          <v-col cols="auto">
            <v-toolbar-title class="headline text-uppercase">
              <router-link to="/" tag="span" style="cursor: pointer">
                Movie Place
              </router-link>
            </v-toolbar-title>
          </v-col>
          <v-spacer></v-spacer>
          <v-col cols="3" align="center">
            <v-text-field
              label="Movie Name"
              v-model="searchString"
              clearable
              hide-details="auto"
              single-line
              prepend-inner-icon="mdi-search-web"
              @keydown.enter.prevent="searchMovie"
            >
            </v-text-field>
          </v-col>
          <v-col cols="auto">
            <v-btn text :disabled="!dataAvailable" @click="searchMovie">
              <span class="mr-2">Search</span>
            </v-btn>
          </v-col>
          <v-col cols="auto">
            <v-badge
              :content="totalFavorites"
              :value="totalFavorites"
              color="green"
              overlap
            >
              <v-btn
                fab
                small
                dark
                depressed
                color="blue darken-1"
                @click="goToFavorites"
              >
                <v-icon>mdi-thumb-up</v-icon>
              </v-btn>
            </v-badge>
          </v-col>
        </v-row>
      </v-container>
    </v-app-bar>

    <v-content>
      <router-view />
    </v-content>
  </v-app>
</template>

<script>
import { mapState } from 'vuex';

export default {
  name: 'App',
  components: {},
  data() {
    return {
      searchString: ''
    };
  },
  methods: {
    searchMovie() {
      this.$router.push('/search/' + this.searchString);
      this.searchString = '';
    },
    goToMovie(id) {
      this.$router.push('/movie/' + id);
    },
    goToFavorites() {
      this.$router.push('/favorites');
    }
  },
  mounted() {},
  computed: {
    dataAvailable() {
      return this.searchString !== null && this.searchString !== '';
    },
    ...mapState('movies', {
      totalFavorites: state => state.favorites.length
    })
  }
};
</script>
